# frozen_string_literal: true

require '/data_importer/lib/json_helper'

class CisaKnownExploitImporter
  attr_accessor :feed_url 

  EXPECTED_KEYS = %i[
    title
    catalog_version
    date_released
    count
    vulnerabilities
  ].freeze

  EMPTY_HASH = EXPECTED_KEYS.map { |k| [k, nil] }.to_h.freeze

  def initialize
    @feed_url = 'https://www.cisa.gov/sites/default/files/feeds/known_exploited_vulnerabilities.json'
  end

  def get_and_transform_json
    json = JsonHelper.read_json_from_url(feed_url)
    json_transformed = JsonHelper.deep_transform_keys(json)
    #json_transformed.map { |h| h.slice(*EXPECTED_KEYS).reverse_merge(EMPTY_HASH) }
  end


  def import
    puts "Now starting import Cisa Known Exploits for #{feed_url}."
    puts '----------' * 12
    cisa_known_exploits = [ get_and_transform_json ] 
    CisaKnownExploit.upsert_all(cisa_known_exploits, unique_by: :date_released)
  end
end
